
private import  mango.io.Stdio,
                mango.io.FilePath,
                mango.io.FileProxy;

/*******************************************************************************

        Recursively scan files and directories, adding filtered files to
        an output structure as we go. Thanks to Chris S for this.
        
*******************************************************************************/

void main()
{       
        /***********************************************************************

        ***********************************************************************/

        struct Dependencies 
        {
                FileProxy[]     mods;
                FilePath[]      pkgs;
        }

        /***********************************************************************

        ***********************************************************************/

        void scanFiles (inout Dependencies deps, FilePath base) 
        {
                /***************************************************************

                        delegate for filtering sub-directories and 
                        D source files

                ***************************************************************/

                bit filter (FilePath fp) 
                {
                        char[]  sbuf = fp.getExtension();

                        if (fp.getName[0] != '.')                       
                            if (sbuf.length == 0 || sbuf == "d")
                                return true;

                        return false;
                }

                /***************************************************************

                ***************************************************************/

                FileProxy  proxy = new FileProxy (base);
                FilePath[] paths = proxy.toList  (&filter);

                // add packages only if there's something in them
                if (paths.length)
                    deps.pkgs ~= base;

                foreach (FilePath x; paths) 
                        {
                        // combine base path with listed file
                        FilePath spliced = new FilePath (x.splice (base));

                        // recurse if this is a directory ...
                        proxy = new FileProxy (spliced);
                        if (proxy.isDirectory()) 
                            scanFiles (deps, spliced);
                        else 
                           deps.mods ~= proxy;
                        }
        }


        /***********************************************************************

        ***********************************************************************/

        Dependencies deps;

        scanFiles (deps, new FilePath(r"\dmd\src\mango"));

        Stdout.put ("-----------------").cr();
        foreach (FileProxy mod; deps.mods)
                 Stdout.put (mod.getPath()).cr();

        Stdout.put ("-----------------").cr();
        foreach (FilePath pkg; deps.pkgs)
                 Stdout.put (pkg).cr();
}

